<!-- Please do not edit this file. Edit the `blah` field in the `package.json` instead. If in doubt, open an issue. -->








[![rucksack](http://i.imgur.com/hSPcrjC.png)](#)











# rucksack

 [![Version](https://img.shields.io/npm/v/rucksack.svg)](https://www.npmjs.com/package/rucksack) [![Downloads](https://img.shields.io/npm/dt/rucksack.svg)](https://www.npmjs.com/package/rucksack)







> JavaScript and CSS bundler.

















## :cloud: Installation

```sh
# Using npm
npm install --save rucksack

# Using yarn
yarn add rucksack
```













## :clipboard: Example



```js
const Rucksack = require("rucksack")


// Create a new bundler
let bundler = new Rucksack({
	aliases: {
		"foo": `${__dirname}/data/bar/foo.js`
	}
})

// Add remote url as resource
bundler.add("https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.js")
bundler.add(`${__dirname}/data/main.js`)
bundler.add(`${__dirname}/data/another-main.js`)
bundler.add(`${__dirname}/data/bar.css`)
bundler.add(`${__dirname}/data/main.css`)
//bundler.add({
//    type: "css",
//    url: "https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.8.0/styles/default.min.css",
//    inline: true
//})

bundler.bundleCSS(`${__dirname}/test.css`)
// => info  [Tuesday, November 28, 2017 06:53:48 AM] Bundling  the styles.
// => warn  [Tuesday, November 28, 2017 06:53:48 AM] Skipping remote @import of "https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.8.0/styles/default.min.css" as resource is not allowed.
// => @import url(https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.8.0/styles/default.min.css);strong{color:#000}strong{color:#ff0}body{background:#fff;-webkit-transform:translate(10px);transform:translate(10px)}

bundler.bundleJS(`${__dirname}/test.js`)
// => info  [Tuesday, November 28, 2017 06:53:48 AM] Bundling  the scripts.
// => (function e(t,n,r){...})
```











## :question: Get Help

There are few ways to get help:



 1. Please [post questions on Stack Overflow](https://stackoverflow.com/questions/ask). You can open issues with questions, as long you add a link to your Stack Overflow question.
 2. For bug reports and feature requests, open issues. :bug:





## :memo: Documentation


### constructor

Ruckasck
Creates a new instance of `Ruckasck`.

#### Params

- **Object** `opts`: The Rucksack options.

#### Return
- **Object** The Rucksack instance.

### `_watchCSS(resPath)`
Watch the CSS paths.

#### Params

- **String** `resPath`: The CSS resource path.

### `addCSS(resPath, inline)`
Adds a new CSS path.

#### Params

- **String** `resPath`: The CSS resource path to add.
- **Boolean** `inline`: Whether to add the CSS content inline or not.

### `bundleJS(output, cb)`
Bundles the JS files.

#### Params

- **String** `output`: The output of the JS script.
- **Function** `cb`: The callback function.

### `bundleCSS(output, cb)`
Bundles the CSS files.

#### Params

- **String** `output`: The output of the CSS script.
- **Function** `cb`: The callback function.

#### Return
- **String** The URL of the script.














## :yum: How to contribute
Have an idea? Found a bug? See [how to contribute][contributing].
















## :dizzy: Where is this library used?
If you are using this library in one of your projects, add it in this list. :sparkles:

 - `bloggify-cli`
 - `bloggify-prebuilt`











## :scroll: License

[MIT][license] © [Bloggify][website]






[license]: /LICENSE
[website]: https://bloggify.org
[contributing]: /CONTRIBUTING.md
[docs]: /DOCUMENTATION.md
